<?php
/**
 * Created by JetBrains PhpStorm.
 * User: leonardocarvalho
 * Date: 03/12/13
 * Time: 08:19
 * To change this template use File | Settings | File Templates.
 */

namespace Importacao\Logic\Util;


class ParametrosJson {

    private $JsonPath;
    public $JsonDecode;

    const AUTOINCREMENT = "@AUTOINCREMENT@";
    const ID_CHAVE_NRORG = 'ID_CHAVE_NRORG';
    const DE_PARA = 'DE_PARA';

    /**
     * @param $JsonPath
     */
    function __construct($JsonPath) {
        $this->JsonPath = $JsonPath;
        $this->JsonDecode = $this->decodeJson($this->JsonPath);
    }

    /**
     * @return mixed
     */
    public function getJsonDecode() {
        return $this->JsonDecode;
    }

    /**
     * @return mixed
     */
    private function decodeJson() {
        $array = json_decode(file_get_contents($this->JsonPath), true);
        return $array;
    }

    /**
     * @return array
     */
    public function getTabelasByAgrupamento($dsagrupador){
        $grupo = array();
        foreach ($this->JsonDecode[$dsagrupador] as $tabela => $labels) {
            $grupo[] = $tabela;
        }
        return $grupo;
    }

    /**
     * @return array
     */
    public function getHierarquiaAgrupamento($dsagrupador){
        $grupo = array();
        foreach ($this->JsonDecode[$dsagrupador] as $tabela => $labels) {
            $grupo[$tabela] = $labels;
        }
        return $grupo;
    }

    /**
     * @return array
     */
    public function getTabelas(){
        $tabelas = array();
        foreach ($this->JsonDecode as $agrupador) {
            foreach ($agrupador as $tabela => $label) {
                $tabelas[] = $tabela;
            }
        }
        return $tabelas;
    }

    /**
     * @return array
     */
    public function getColunasLabel(){
        $colunasLabel = array();
        foreach ($this->JsonDecode as $agrupador) {
            foreach ($agrupador as $tabela) {
                foreach ($tabela as $colunaLabel => $nmcoluna) {
                    $colunasLabel[] = $colunaLabel;
                }
            }
        }
        return $colunasLabel;
    }

    /**
     * @return array
     */
    public function getColunasLabelByAgrupador($dsagrupador){
        $colunasLabel = array();
        foreach ($this->JsonDecode[$dsagrupador] as $tabela) {
            foreach ($tabela as $colunaLabel => $nmcoluna) {
                $colunasLabel[] = $colunaLabel;
            }
        }
        return $colunasLabel;
    }

    /**
     * @return array
     */
    public function getColunasLabelByTabela($tabela){
        $colunasLabel = array();
        foreach ($this->JsonDecode as $table) {
            foreach ($table[$tabela] as $colunaLabel => $nmcoluna) {
                $colunasLabel[$colunaLabel] = $colunaLabel;
            }
        }
        return $colunasLabel;
    }

    /**
     * @return array
     */
    public function getNmcolunaByLabel($label){
        $colunas = array();
        foreach ($this->JsonDecode as $agrupador) {
            foreach ($agrupador as $tabela) {
                return $tabela[$label];
            }
        }
        return null;
    }

    /**
     * Retorna as colunas que são auto incremente por agrupamento
     *
     * @param $agrupamento
     * @return array
     *
     */
    public function getColunasExtras($agrupamento) {
        $colunas = array();
        foreach ($this->JsonDecode[$agrupamento] as $tabela) {
            foreach ($tabela as $label => $valor) {
                if ($valor === self::AUTOINCREMENT || $label === self::ID_CHAVE_NRORG
                    || $label === self::DE_PARA) {
                    if ($label === self::ID_CHAVE_NRORG || $label === self::DE_PARA) {
                        $colunas[$label] = $valor;
                    } else {
                        $colunas[$label] = $label;
                    }

                }
            }
        }
        return array_unique($colunas);
    }

}

$parametros = new ParametrosJson('../sample.json');
//$array = $parametros->getNmcolunaByLabel('INICIO_VIGENCIA');
//$array = $parametros->getColunasExtras('OCUPACAO');
//print_r($array);