<?php
namespace MerendaPlanejamento\Repositories;

class Prevconspme extends \Doctrine\ORM\EntityRepository
{


    public function consultaPrevisaoConsumoMerenda($nrorg, $filial, $dtInicio, $dtFinal){
        $sql = "SELECT DISTINCT PV.CDFILCENTPME,
                       PV.CDFILIAL,
                       PV.DTPREVCONPME,
                       PV.CDSERVFILI
                  FROM FILIAL   FI,
                       SERVICO  SV,
                       PREVCONSPME PV
                 WHERE PV.NRORG = :P_NRORG
                   AND PV.CDFILIAL = :P_CDFILIAL
                   AND PV.DTPREVCONPME BETWEEN :P_DTINICIAL AND :P_DTFINAL
                   AND SV.NRORG = PV.NRORG
                   AND SV.CDFILIAL     = PV.CDFILCENTPME
                   AND SV.CDSERVFILI   = PV.CDSERVFILI
                   AND SV.IDSERVATIV   <> 'N'
                   AND FI.NRORG = SV.NRORG
                   AND FI.CDFILIAL     = PV.CDFILIAL
                 ORDER BY PV.CDFILCENTPME,
                       PV.CDFILIAL,
                       PV.CDSERVFILI,
                       PV.DTPREVCONPME";

        $params = array(
            "P_NRORG"     => $nrorg,
            "P_CDFILIAL"  => $filial,
            "P_DTINICIAL" => $dtInicio,
            "P_DTFINAL"   => $dtFinal,
        );

        $entityManager = $this->getEntityManager();
        $result = $entityManager->getConnection()->fetchAll($sql, $params);
        return count($result) > 0 ? $result : false;

    }


    public function consultaProdutosPrevisao($nrorg, $filial, $filialCentral, $servico, $dtPrevisao){
        $sql = "SELECT DISTINCT PV.CDFILIAL,
                       PV.CDPRODUTO
                  FROM PREVCONSPME PV
             LEFT JOIN (SELECT CDFILIAL,
                               CDSERVFILI,
                               DTCARDIAPME,
                               SUM(QTCOMESTCPME) AS QTCOMESTCPME,
                               SUM(QTCLIESTCPME) AS QTCLIESTCPME,
                               NRORG
                          FROM CARDIAPME
                         WHERE NRORG        = :P_NRORG
                           AND CDFILCENTPME = :P_CDFILCENTPME
                           AND CDFILIAL     = :P_CDFILIAL
                           AND CDSERVFILI   = :P_CDSERVFILI
                           AND DTCARDIAPME  = :P_DTPREVCONPME
                         GROUP BY CDFILIAL, CDSERVFILI, DTCARDIAPME, NRORG
                       ) COM ON COM.NRORG       = PV.NRORG
                            AND COM.CDFILIAL    = PV.CDFILIAL
                            AND COM.CDSERVFILI  = PV.CDSERVFILI
                            AND COM.DTCARDIAPME = PV.DTPREVCONPME
                 WHERE PV.NRORG           = :P_NRORG
                   AND PV.CDFILCENTPME    = :P_CDFILCENTPME
                   AND PV.CDFILIAL        = :P_CDFILIAL
                   AND PV.DTPREVCONPME    = :P_DTPREVCONPME
                   AND PV.CDSERVFILI      = :P_CDSERVFILI";

        $params = array(
            "P_NRORG" => $nrorg,
            "P_CDFILIAL" => $filial,
            "P_CDFILCENTPME" => $filialCentral,
            "P_CDSERVFILI" => $servico,
            "P_DTPREVCONPME" => $dtPrevisao,
        );

        $entityManager = $this->getEntityManager();
        $result = $entityManager->getConnection()->fetchAll($sql, $params);
        return is_array($result) ? $result : false;

    }
}